#include <string.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include "ll.h"

ListNode* LinkedList_create_node(void* data, int size) {
  ListNode* node = malloc(sizeof(ListNode));
  node->value = data;
  node->value_size = size;
  node->prev = NULL;
  node->next = NULL;
  return node;
}   

LinkedList* LinkedList_create(void* data, int size) {
  LinkedList* ll = malloc(sizeof(LinkedList));
  ll->count = 1;
  ll->root = LinkedList_create_node(data, size);
  return ll;
}   

void LinkedList_add(LinkedList* ll, void* value, int size) {
  ListNode* new = LinkedList_create_node(value, size);
  new->next = ll->root;
  ll->root->prev = new;
  ll->root = new;
}

void LinkedList_print(LinkedList* ll) {
  ListNode* node = ll->root;
  while (node != NULL) {
    printf("[SIZE: %d  DATA: ", node->value_size);
    for (int i = 0; i < node->value_size; i++) {
      printf("%c", ((char*)node->value)[i]);
    }
    printf("] -> ");
    node = node->next;
  }
  printf("NULL\n");
}

bool LinkedList_contains(LinkedList* ll, void* data, int size) {
  ListNode* node = ll->root;
  while (node != NULL) {
    if (node->value_size == size && strncmp(node->value, data, size) == 0) {
      return true;
    }
    node = node->next;
  }
  return false;
}

void LinkedList_delete(LinkedList* ll) {
  ListNode* node = ll->root;
  while (node != NULL) {
    ListNode *temp = node->next;
    free(node);
    node = temp;
  }
  free(ll);
}
